#!/bin/bash

#startDate = "19970621113000" ;
#endDate = "19970622023000" ;
new_input=1


if [ $new_input = 0 ] ; then
   ncdump -h setup/cas.nc > tmp
   surfaceType="land" ;  surfaceForcing="0" ;  forcingForcingWind="z0"
else
   ncdump -h cas.nc | sed -e 's/qvadv/qadv/g' > tmp
   forc_ustar=0 ; forc_u=0 ; forc_v=0 ; z0=0.
fi


\rm cas.def ; touch cas.def

for var in Latitude Longitude \
	tadv tadvh tadvv trad qadv qadvh qadvv \
	forc_omega forc_w forc_geo \
       	nudging_u nudging_v nudging_t nudging_q \
	zorog z0  \
	surfaceType surfaceForcing forcingForcingWind \
	forc_ustar forc_u forc_v \
	; do

	val=`grep "$var =" tmp | tail -1 | cut -d= -f2 | awk ' { print $1 } ' | sed -e 's/"//g' `
	echo $var =$val
	# Regarder le probleme de trad
	if [ "$val" != "" ] ; then
	varname=$var
		case $var in
			Latitude) varname=rlat ;;
			Longitude) varname=rlon ;; 
			surfaceForcing) varname=ok_flux_surf ; if [ $val = ts ] ; then val=n ; else val=y ; fi ;; 
			surfaceType) varname=nat_surf
				case `echo $val | sed -e 's/ //g'` in
					land) val=1 ;;
					ocean) val=2 ;;
					seaice) val=2 ;;
					landice) val=2 ;;
				esac ;;
			trad) varname=iflag_radia
				case $val in
					adv) val=0 ;;
					*) val=1
				esac
		esac
		echo $varname=$val >> cas.def
	fi
done

############# Gestion du calendrier ###################################
time_i=`ncdump -h cas.nc | grep startDate | cut -d\" -f2`
time_f=`ncdump -h cas.nc | grep endDate | cut -d\" -f2`
yr_i=`echo $time_i | cut -c1-4`
mo_i=`echo $time_i | cut -c5-6`
da_i=`echo $time_i | cut -c7-8`
hr_i=`echo $time_i | cut -c9-10`
mn_i=`echo $time_i | cut -c11-12`
sc_i=`echo $time_i | cut -c13-14`
echo $yr_i $mo_i  $da_i $hr_i $mn_i $sc_i $time_i
yr_f=`echo $time_f | cut -c1-4`
mo_f=`echo $time_f | cut -c5-6`
da_f=`echo $time_f | cut -c7-8`
hr_f=`echo $time_f | cut -c9-10`
mn_f=`echo $time_f | cut -c11-12`
sc_f=`echo $time_f | cut -c13-14`
echo $yr_f $mo_f  $da_f $hr_f $mn_f $sc_f $time_f
(( yr_d = $yr_f - $yr_i ))
(( mo_d = $mo_f - $mo_i ))
(( da_d = $da_f - $da_i ))
(( hr_d = $hr_f - $hr_i ))
(( mn_d = $mn_f - $mn_i ))
(( sc_d = $sc_f - $sc_i ))

echo PREVOIR DE PASSER AU CALENDRIER VRAI
calend=360

# Jour compte depuis le debut de l'annee
if [ $calend = 360 ] ; then
	d0mo=( 0 30 60 90 120 150 180 210 240 270 300 330 )
	yr_length=360
fi
day_i=$(( d0mo[$(( $mo_i - 1 ))] +  $da_i ))

# Longeur de la simulation en jours, incluant la prise en compte des heures
hour_i=$(( $day_i * 24 + $hr_i ))
hour_f=$(( $(( d0mo[$(( $mo_f - 1 ))] +  $da_f + $yr_d * $yr_length )) * 24 + $hr_f ))
nday=$(( $(( $hour_f - $hour_i )) / 24 + 1 ))



echo dayref=$(( d0mo[$(( $mo_i - 1 ))] +  $da_i )) >> cas.def
echo anneeref=$yr_i >> cas.def
echo nday=$nday >> cas.def
echo time_ini=`echo $hr_i $mn_i $sc_i | awk ' { print ( $1 * 3600 + $2 * 60 + $3 ) / 3600. } '`  >> cas.def
